 include tios.h
 include graphlib.h
 include userlib.h

oldint equ $57B8
Score equ $57BC
BoardPos equ $57BE
Board equ $57BF
SelectFlag equ $5810
OldBoardPos equ $5811
GoodMoveFlag equ $5812
HiFlag equ $5813
keystat equ $5814
buf equ $5814
OnDeck equ $5821

 xdef _main
 xdef _comment
 xdef _ti89

_main:
 jsr graphlib::clr_scr
 move.l ($040064),(oldint)
 move.l #int1,($040064)
 jsr graphlib::gray4
 not.b (graphlib::choosescreen)
 move.l (graphlib::plane1),a4
 move.l a4,a1
 bsr clr_scr2
 moveq #60,d7
 bsr CenterName
 move.w #4,-(a7)
 pea Name
 move.w #91,-(a7)
 move.w d7,-(a7)
 jsr tios::DrawStrXY
 lea 10(a7),a7
 move.l a4,a1
 clr.w d0		
 clr.w d1
 moveq #99,d2
 clr.w d3
 moveq #9,d4
HorizLineLoop:
 jsr graphlib::horiz
 add.b #11,d1
 dbra d4,HorizLineLoop
 clr.b d1
 moveq #9,d3
VertLineLoop:
 jsr graphlib::vert
 add.b #11,d0
 dbra d3,VertLineLoop
 lea SelectFlag,a6
 clr.b (a0)
 bsr DrawCursor
 bsr PandD3
 bsr Add4ToScreen

KeyWait:
 bsr GetKeyStat
 btst.b #6,keystat+1
 beq Exit
 btst.b #4,keystat
 beq Select
 btst.b #3,keystat
 beq MoveRight
 btst.b #2,keystat
 beq MoveDown
 btst.b #1,keystat
 beq MoveLeft
 btst.b #0,keystat
 beq MoveUp
 bra KeyWait

Exit:
 clr.b (graphlib::choosescreen)
 jsr graphlib::gray2
 move.l (oldint),($040064)
 bsr clr_scr
 lea HiFlag,a0
 tst.b (a0)
 beq Exit2
 lea Score,a0
 lea HiScore(pc),a1
 move.w (a0),(a1)
 move.w #1,-(a7)
 jsr tios::FontSetSys
 move.w #4,-(a7)
 pea EnterStr
 clr.w -(a7)
 move.w #32,-(a7)
 jsr tios::DrawStrXY
 move.w #4,-(a7)
 pea _comment
 move.w #10,-(a7)
 move.w #35,-(a7)
 jsr tios::DrawStrXY
 lea 22(a7),a7
 lea Name(pc),a2
 clr.b d5
NameMain:
 jsr userlib::idle_loop
 cmp.w #13,d0
 beq Exit2
 cmp.w #257,d0
 beq Delete
 moveq #26,d1
 lea value(pc),a0
 lea key(pc),a1
HiNameLoop:
 move.w (a0)+,d6
 cmp.w d0,d6
 beq FoundLetter
 addq #1,a1
 dbra d1,HiNameLoop
 bra NameMain

FoundLetter:
 cmp.b #10,d5
 bge NameMain
 addq #1,d5
 move.b (a1),(a2)+
 clr.b (a2)
 bra Redundant

Delete:
 tst.b d5
 beq NameMain
 subq #1,d5
 clr.b -(a2)
Redundant:
 move.w #4,-(a7)
 pea Blank
 move.w #54,-(a7)
 move.w #50,-(a7)
 jsr tios::DrawStrXY
 move.w #160,d7
 bsr CenterName
 move.w #4,-(a7)
 pea Name
 move.w #54,-(a7)
 move.w d7,-(a7)
 jsr tios::DrawStrXY
 lea 20(a7),a7
 bra NameMain

Exit2:
 rts

Add4ToScreen:
 moveq #3,d3
 lea OnDeck,a2
AddLoop:
 moveq #80,d0
 lea Board,a0
FullCheckLoop:
 tst.b (a0)+
 beq TheresRoom
 dbra d0,FullCheckLoop
 bra DoneAdd
TheresRoom:
 moveq #81,d0
 jsr userlib::random
 lea Board,a0
 adda.l d0,a0
 tst.b (a0)
 bne TheresRoom
 bsr Board_to_Coords
 addq #2,d0
 addq #2,d1
 clr.w d2
 move.b (a2)+,d2
 move.b d2,(a0)
 bsr DrawSprite
 dbra d3,AddLoop
DoneAdd:
 bsr PandD3
 bra Check

Board_to_Coords:
 move.w d0,d1
 divu #9,d1
 mulu #9,d1
 sub.w d1,d0
 mulu #11,d0 
 divu #9,d1
 mulu #11,d1
 rts 

DrawCursor:
 clr.w d0
 lea BoardPos,a5
 move.b (a5),d0
 bsr Board_to_Coords
 moveq #11,d2
 moveq #11,d3
 clr.w d4
 move.l #$4C00,a3
 move.l a3,a1
 jsr graphlib::fill
 moveq #9,d2
 moveq #9,d3
 addq #1,d0
 addq #1,d1
 jmp graphlib::fill

MoveUp:
 clr.l d0
 move.b (a5),d0
 cmp.b #8,d0
 ble KeyWait
 tst.b (a6)
 beq KeepUp
 sub.b #9,d0
 bsr RestoreSelected
 bne KeyWait
KeepUp:
 bsr DrawCursor
 sub.b #9,(a5)
 bra FinishMove

MoveDown:
 clr.l d0
 move.b (a5),d0
 cmp.b #72,d0
 bge KeyWait
 tst.b (a6)
 beq KeepDown
 add.b #9,d0
 bsr RestoreSelected
 bne KeyWait
KeepDown:
 bsr DrawCursor
 add.b #9,(a5)
 bra FinishMove

MoveLeft:
 clr.l d0
 move.b (a5),d0
 add.b #9,d0
LeftLoop1:
 sub.b #9,d0
 tst.b d0
 beq KeyWait
 bgt LeftLoop1
 move.b (a5),d0
 subq #1,d0
 tst.b (a6)
 beq KeepLeft
 bsr RestoreSelected
 bne KeyWait
KeepLeft:
 bsr DrawCursor
 subq.b #1,(a5)
 bra FinishMove

MoveRight:
 clr.l d0
 move.b (a5),d0
 add.b #10,d0
RightLoop1:
 sub.b #9,d0
 tst.b d0
 beq KeyWait
 bgt RightLoop1
 move.b (a5),d0
 addq #1,d0
 tst.b (a6)
 beq KeepRight
 bsr RestoreSelected
 bne KeyWait
KeepRight:
 bsr DrawCursor
 addq.b #1,(a5)
FinishMove:
 bsr DrawCursor
 bsr Delay
 bra KeyWait

int1:
 move.l APD_INIT,APD_TIMER
 rte

Select:
 bsr GetKeyStat
 btst.b #4,keystat
 beq Select
 tst.b (a6)
 bne UnSelect
 clr.l d0
 move.b (a5),d0
 lea OldBoardPos,a0
 move.b d0,(a0)
 lea Board,a0
 adda.l d0,a0
 tst.b (a0)
 beq KeyWait
 not.b (a6)
 bsr Board_to_Coords
 addq #1,d0
 addq #1,d1
 moveq #9,d2
 moveq #9,d3
 clr.w d4
 move.l a3,a1
 jsr graphlib::fill
 move.l a4,a1
 jsr graphlib::fill
 bra KeyWait

UnSelect:
 move.b (a5),d0
 lea OldBoardPos,a2
 cmp.b (a2),d0
 bne Move
 clr.b (a6)
 clr.w d0
 move.b (a5),d0
 bsr Board_to_Coords
 addq #1,d0
 addq #1,d1
 moveq #9,d2
 moveq #9,d3
 clr.w d4
 move.l a3,a1
 jsr graphlib::fill
 move.l a4,a1
 jsr graphlib::fill
 bra KeyWait

Move:
 clr.l d0
 move.b (a5),d0
 lea Board,a0
 adda.l d0,a0
 tst.b (a0)
 bne KeyWait
 clr.b (a6)
 clr.l d0
 move.b (a2),d0
 lea Board,a1
 adda.l d0,a1
 move.b (a1),(a0)
 move.b (a0),-(a7)
 clr.b (a1)
 clr.w d0
 move.b (a2),d0
 bsr Board_to_Coords
 addq #1,d0
 addq #1,d1
 moveq #9,d2
 moveq #9,d3
 moveq #1,d4
 move.l a3,a1
 jsr graphlib::fill
 move.l a4,a1
 jsr graphlib::fill
 clr.w d0
 move.b (a5),d0
 bsr Board_to_Coords
 addq #2,d0
 addq #2,d1
 clr.l d2
 move.b (a7)+,d2
 clr.w d3
 bsr DrawSprite
 bsr Check
 tst.b (a2)
 bne KeyWait
 bsr Add4ToScreen
 bra KeyWait

RestoreSelected:
 clr.l d2
 lea OldBoardPos,a0
 move.b (a0),d2
 lea Board,a0
 adda.l d2,a0
 move.b (a0),d1
 clr.b (a0)
 lea Board,a1
 adda.l d0,a1
 tst.b (a1)
 sne d2
 move.b d1,(a0)
 tst.b d2
 rts

GetKeyStat:
 lea	 keystat,a0
 move.w  #$FFFE,d0
 moveq	 #1,d1
GetKeys:
 move.w  d0,$600018
 moveq #16,d2
AllowWriteLoop
 nop
 dbra d2,AllowWriteLoop
 move.b  $60001B,(a0)+
 rol.w	 #1,d0
 dbra	 d1,GetKeys
 rts

Delay:
 move.w #65535,d6
NopLoop:
 nop
 dbra d6,NopLoop
 rts

PandD3:
 moveq #113,d0
 moveq #21,d1
 moveq #34,d2
 moveq #7,d3
 moveq #1,d4
 move.l a3,a1
 jsr graphlib::fill
 move.l a4,a1
 jsr graphlib::fill
 clr.w d3
 moveq #3,d1
 lea OnDeck,a0
Pickloop:
 moveq #4,d0
 jsr userlib::random
 addq #1,d0
 move.b d0,(a0)+
 dbra d1,Pickloop
 moveq #3,d4
 moveq #113,d0
 moveq #21,d1
 lea OnDeck,a2
OnDeckLoop:
 clr.l d2
 move.b (a2)+,d2
 bsr DrawSprite
 add.b #9,d0
 dbra d4,OnDeckLoop
 rts

Checker:
 lea Board,a0
 adda.l d0,a0
OuterLoop:
 moveq #4,d1
InnerLoop:
 tst.b (a0)
 beq TryNext
 move.b (a0),d0
 cmp.b #4,d0
 ble Go
 sub.b #4,d0
Go:
 move.b d0,d6
 addq #4,d6
 move.l a0,a2
 moveq #3,d7
CmpLoop:
 add.l d3,a2
 cmp.b (a2),d0
 beq GoodCmp
 cmp.b (a2),d6
 bne TryNext
GoodCmp:
 dbra d7,CmpLoop
 move.l a0,a2
 sub.l d3,a2
 lea Score,a1
 addq.w #5,(a1)
 moveq #4,d7
Add4Loop:
 add.l d3,a2
 cmp.b #4,(a2)
 bgt DontAdd4
 addq.b #4,(a2)
DontAdd4:
 dbra d7,Add4Loop
TryNext:
 adda.l d4,a0
 dbra d1,InnerLoop
 adda.l d5,a0
 dbra d2,OuterLoop
 rts

Check:
 clr.l d0
 moveq #8,d2
 moveq #1,d3
 moveq #1,d4
 moveq #4,d5
 bsr Checker
 clr.l d0
 moveq #8,d2
 moveq #9,d3
 moveq #9,d4
 moveq #-44,d5
 bsr Checker
 clr.l d0
 moveq #4,d2
 moveq #10,d3
 moveq #1,d4
 moveq #4,d5
 bsr Checker
 moveq #4,d0
 moveq #4,d2
 moveq #8,d3
 moveq #1,d4
 moveq #4,d5
 bsr Checker
 bsr Delay
 lea GoodMoveFlag,a2
 clr.b (a2)
 moveq #80,d6
 clr.b d5
 lea Board,a0
ClearBoardLoop:
 cmp.b #4,(a0)+
 ble DoNothing
 clr.w d0
 move.b d5,d0
 bsr Board_to_Coords
 addq #2,d0
 addq #2,d1
 moveq #7,d2
 moveq #7,d3
 moveq #1,d4
 move.l a3,a1
 jsr graphlib::fill
 move.l a4,a1
 jsr graphlib::fill
 clr.b -1(a0)
 move.b #1,(a2)
DoNothing:
 addq #1,d5
 dbra d6,ClearBoardLoop
 lea Score,a0
 move.w (a0),d0
 lea HiScore(pc),a1
 cmp.w (a1),d0
 ble WhoCares
 lea HiFlag,a0
 move.b #1,(a0)
WhoCares:
 move.w #2,-(a7)
 jsr tios::FontSetSys
 lea Score,a0
 move.w (a0),d0
 move.w #5,d1
 lea buf,a0
 bsr ConvStr
 move.w #4,-(a7)
 pea (a0)
 move.w #61,-(a7)
 move.w #110,-(a7)
 jsr tios::DrawStrXY
 move.w (a1),d0
 move.w #5,d1
 lea buf,a0
 bsr ConvStr
 move.w #4,-(a7)
 pea (a0)
 move.w #80,-(a7)
 move.w #110,-(a7)
 jsr tios::DrawStrXY
 lea 22(a7),a7
 rts

CenterName:
 lea Name(pc),a0
 clr.w d0
NameLoop:
 tst.b (a0)+
 beq NameContinue
 addq #1,d0
 bra NameLoop
NameContinue:
 mulu #6,d0
 move.b d7,d6
 sub.w d0,d7
 divu #2,d7
 sub.b #160,d6
 neg.b d6
 add.w d6,d7
 rts

ConvStr:
 adda.l d1,a0
 clr.b (a0)
 subq.b #1,d1
RepConv:
 divu #10,d0
 move.l d0,d2
 lsr.l #8,d2
 lsr.l #8,d2
 add.b #48,d2
 move.b d2,-(a0)
 and.l #$FFFF,d0
 dbra d1,RepConv
 rts

DrawSprite:
 lea Diamond1(pc),a0
 subq #1,d2
 mulu #12,d2
 adda.l d2,a0
 move.l a3,a1
 jsr graphlib::put_sprite_mask
 move.l a4,a1
 adda.l #12,a0
 jsr graphlib::put_sprite_mask
 rts

clr_scr:
 move.l a3,a1
clr_scr2:
 move.w #2999,d0
clr_loop:
 clr.b (a1)+
 dbra d0,clr_loop
 rts

Diamond1
 dc.w 8
 dc.w 1
 dc.b %00011000
 dc.b %00100100
 dc.b %01000010
 dc.b %10000001
 dc.b %10000001
 dc.b %01000010
 dc.b %00100100
 dc.b %00011000
Diamond2
 dc.w 8
 dc.w 1
 dc.b %00011000
 dc.b %00100100
 dc.b %01000010
 dc.b %10000001
 dc.b %10000001
 dc.b %01000010
 dc.b %00100100
 dc.b %00011000
Diamond3
 dc.w 8
 dc.w 1
 dc.b %00011000
 dc.b %00111100
 dc.b %01111110
 dc.b %11111111
 dc.b %11111111
 dc.b %01111110
 dc.b %00111100
 dc.b %00011000
Diamond4
 dc.w 8
 dc.w 1
 dc.b %00011000
 dc.b %00111100
 dc.b %01111110
 dc.b %11111111
 dc.b %11111111
 dc.b %01111110
 dc.b %00111100
 dc.b %00011000
 dc.w 8
 dc.w 1
 dc.b %00011000
 dc.b %00100100
 dc.b %01000010
 dc.b %10000001
 dc.b %10000001
 dc.b %01000010
 dc.b %00100100
 dc.b %00011000

_comment dc.b "Diamond Master!",0
value dc.w 61,40,41,44,47,124,55,56,57,42,149,52,53,54,45,258,49,50,51,116,43,48,46,120,121,122,173
HiScore dc.w 0
Name dc.b "          ",0
key dc.b "ABCDEFGHIJKLMNOPQRSTUVWXYZ "
Blank dc.b "          ",0
EnterStr dc.b "Enter your name,",0

 end
